# List all custom fields

GET https://api.letsdeel.com/rest/v2/contracts/custom_fields

Use this endpoint to retrieve all custom fields defined for contracts. Use it when building contract creation or edit flows that need to display field options and requirements. This operation is read-only and non-destructive.
 **Token scopes**: `contracts:read`

Reference: https://developer.deel.com/api/endpoints/custom-fields-contracts/get-contract-custom-fields

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Deel HRIS SCIM API
  version: 1.0.0
paths:
  /contracts/custom_fields:
    get:
      operationId: get-contract-custom-fields
      summary: List all custom fields
      description: >-
        Use this endpoint to retrieve all custom fields defined for contracts.
        Use it when building contract creation or edit flows that need to
        display field options and requirements. This operation is read-only and
        non-destructive.
         **Token scopes**: `contracts:read`
      tags:
        - subpackage_customFieldsContracts
      parameters:
        - name: Authorization
          in: header
          description: >
            ## Authentication

            The Deel API uses bearer tokens to authenticate requests. All API
            calls must be made over HTTPS — calls over plain HTTP or without
            authentication will fail.


            ```curl

            curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
              -H 'Authorization: Bearer YOUR-TOKEN-HERE'
            ```


            [Learn more about authentication](/api/authentication)
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/custom-fields-contracts_getContractCustomFields_Response_200
        '400':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '401':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '403':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '404':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '500':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
servers:
  - url: https://api.letsdeel.com/rest/v2
  - url: https://api-staging.letsdeel.com/rest/v2
components:
  schemas:
    ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsTypeOneOf0Name:
      type: string
      enum:
        - text
        - number
        - date
        - percentage
      description: Simple types
      title: >-
        ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsTypeOneOf0Name
    ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsType0:
      type: object
      properties:
        name:
          $ref: >-
            #/components/schemas/ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsTypeOneOf0Name
          description: Simple types
      required:
        - name
      title: >-
        ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsType0
    ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsTypeOneOf1Name:
      type: string
      enum:
        - currency
      description: Currency type
      title: >-
        ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsTypeOneOf1Name
    ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsType1:
      type: object
      properties:
        name:
          $ref: >-
            #/components/schemas/ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsTypeOneOf1Name
          description: Currency type
        currency:
          type:
            - string
            - 'null'
          description: Currency code (null when is_fixed is false)
        is_fixed:
          type: boolean
          description: When currency is fixed, only the amount can be edited by the users
      required:
        - name
        - is_fixed
      title: >-
        ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsType1
    ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsTypeOneOf2Name:
      type: string
      enum:
        - list
        - multiselect
      description: List types
      title: >-
        ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsTypeOneOf2Name
    ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsType2:
      type: object
      properties:
        name:
          $ref: >-
            #/components/schemas/ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsTypeOneOf2Name
          description: List types
        options:
          type: array
          items:
            type: string
          description: List of options for the custom field
      required:
        - name
        - options
      title: >-
        ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsType2
    ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsType:
      oneOf:
        - $ref: >-
            #/components/schemas/ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsType0
        - $ref: >-
            #/components/schemas/ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsType1
        - $ref: >-
            #/components/schemas/ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsType2
      description: >-
        Type configuration of the custom field including its data type and
        type-specific properties
      title: >-
        ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsType
    ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsSettingsAccessProvidedBy:
      type: string
      enum:
        - organization
        - worker
      description: Entity providing access to the custom field
      title: >-
        ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsSettingsAccessProvidedBy
    ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsSettingsAccess:
      type: object
      properties:
        provided_by:
          oneOf:
            - $ref: >-
                #/components/schemas/ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsSettingsAccessProvidedBy
            - type: 'null'
          description: Entity providing access to the custom field
        is_sensitive:
          type: boolean
          description: Whether the custom field is sensitive
        group_permission_set:
          type:
            - string
            - 'null'
          description: Permission set identifier for the custom field
      required:
        - is_sensitive
      description: Access settings for the custom field
      title: >-
        ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsSettingsAccess
    ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsSettingsWorkerTypesItems:
      type: string
      enum:
        - eor
        - contractor
        - hris_direct_employee
        - direct_employee
      title: >-
        ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsSettingsWorkerTypesItems
    ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsSettings:
      type: object
      properties:
        access:
          $ref: >-
            #/components/schemas/ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsSettingsAccess
          description: Access settings for the custom field
        required:
          type: boolean
          description: Whether the custom field is required
        countries:
          type: array
          items:
            type: string
          description: >-
            Countries for which the custom field is applicable. Omitted when
            applicable to all.
        is_enabled:
          type: boolean
          description: Whether the custom field is enabled
        worker_types:
          type: array
          items:
            $ref: >-
              #/components/schemas/ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsSettingsWorkerTypesItems
          description: >-
            Worker types for which the custom field is applicable. Omitted when
            applicable to all.
      required:
        - access
        - required
        - is_enabled
      description: >-
        Configuration settings for the custom field including requirements,
        visibility, and access controls
      title: >-
        ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsSettings
    ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsPlacement:
      type: string
      enum:
        - profile
        - contract
      description: Valid placements for custom field
      title: >-
        ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsPlacement
    ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItems:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: Unique identifier of the custom field
        name:
          type: string
          description: Name of the custom field
        type:
          $ref: >-
            #/components/schemas/ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsType
          description: >-
            Type configuration of the custom field including its data type and
            type-specific properties
        settings:
          $ref: >-
            #/components/schemas/ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsSettings
          description: >-
            Configuration settings for the custom field including requirements,
            visibility, and access controls
        placement:
          oneOf:
            - $ref: >-
                #/components/schemas/ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItemsPlacement
            - type: 'null'
          description: Valid placements for custom field
        created_at:
          type: string
          format: date-time
          description: Creation date of the custom field
        description:
          type:
            - string
            - 'null'
          description: Description of the custom field
      required:
        - id
        - name
        - type
        - settings
        - created_at
      title: ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItems
    custom-fields-contracts_getContractCustomFields_Response_200:
      type: object
      properties:
        data:
          type: array
          items:
            $ref: >-
              #/components/schemas/ContractsCustomFieldsGetResponsesContentApplicationJsonSchemaDataItems
      required:
        - data
      title: custom-fields-contracts_getContractCustomFields_Response_200
    ApiErrorRequest:
      type: object
      properties:
        method:
          type: string
          description: The HTTP method of the failed request
        url:
          type: string
          description: The relative URL of the failed request
        status:
          type: number
          format: double
          description: The status code of the response
        api_req_id:
          type: string
          description: The request ID of the failed request
        docs:
          type: string
          description: >-
            A link to the official documentation for the requested endpoint
            resource
        source:
          type: string
          description: The source handler which produced the returned error
        code:
          type: number
          format: double
          description: The code of the source handler which produced the returned error
      title: ApiErrorRequest
    ApiError:
      type: object
      properties:
        message:
          type: string
          description: A description of the returned error
        path:
          type: string
          description: The JSON path where input validation failed
      title: ApiError
    ApiErrorContainer:
      type: object
      properties:
        request:
          $ref: '#/components/schemas/ApiErrorRequest'
        errors:
          type: array
          items:
            $ref: '#/components/schemas/ApiError'
      title: ApiErrorContainer
  securitySchemes:
    deelToken:
      type: http
      scheme: bearer
      description: >
        ## Authentication

        The Deel API uses bearer tokens to authenticate requests. All API calls
        must be made over HTTPS — calls over plain HTTP or without
        authentication will fail.


        ```curl

        curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
          -H 'Authorization: Bearer YOUR-TOKEN-HERE'
        ```


        [Learn more about authentication](/api/authentication)
    oauth2:
      type: http
      scheme: bearer
      description: >-
        Standard OAuth2 security scheme based on
        https://swagger.io/docs/specification/authentication/

```

## SDK Code Examples

```python
import requests

url = "https://api.letsdeel.com/rest/v2/contracts/custom_fields"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/v2/contracts/custom_fields';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/v2/contracts/custom_fields"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/v2/contracts/custom_fields")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.letsdeel.com/rest/v2/contracts/custom_fields")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.letsdeel.com/rest/v2/contracts/custom_fields', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/v2/contracts/custom_fields");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/v2/contracts/custom_fields")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```